Program Fractal;

Uses Graph, Crt;

Const

 PathToDrivers = '.';
Var

	Driver, Mode: Integer;


Function Pow (Num, Expoente: Integer): Integer;
Begin
  If (Expoente=0) Then
    Pow:=1
  Else
    Pow:=Num*Pow (Num, Expoente-1);
End;

Var

  { Variaveis para o fractal }
  max_int, max_cor, nx, ny, tela_x_max, tela_y_max, cor: Integer;
  dx, dy, xx, yy, r, p, q, x0, y0, x, y,
  pmin, pmax, qmin, qmax, p0, q0: Real;

  { Variaveis para o modo grafico }
  max_num_cor, gd, gm: Integer;
  m: char;
  saida:Text;

  { Variaveis para a compressao }
  Cor_Ant, Cont, Posic: Integer;
  Bit, Teste: Byte;
  Cores, Repeticoes: Array [1..8] of Byte;
  Gravar: Boolean;

  { Variaveis para a definicao da janela do aprofundamento }
  cx, cy,
  cx_ant, cy_ant: Integer; { Cursor }
  Resposta: Char;
  flag: Integer;
  Novo_pmin, Novo_pmax,
  Novo_qmin, Novo_qmax: Real;

Begin

  pmin := -2.25;
  pmax := 0.75;
  qmin := -1.5;
  qmax := 1.5;

Repeat

  tela_x_max := 640;
  tela_y_max := 480;
  assign (saida, 'EXPLORER.FRC');
  rewrite (saida);

    Driver:=9;
  Mode:=2;
  initGraph(Driver, Mode, PathToDrivers);
  max_int:=100;
  max_cor:=256;
  nx:=-1;
  ny:=-1;

  dx:=(pmax-pmin)/(tela_x_max-1);
  dy:=(qmax-qmin)/(tela_y_max-1);

  cor_ant:=-1;
  bit:=0;
  Posic:=0;
  gravar:=False;

  nx:=-1;
  While (nx<=Tela_x_Max) do Begin
    Inc (nx);
    ny:=-1;
    While (ny<=Tela_y_Max) do Begin
      Inc (ny);
      p:=pmin+nx*dx;
      q:=qmin+ny*dy;
      cor:=0;
      x:=0;
      y:=0;
      r:=0;
      While (r <= max_int) and (cor < max_cor) do Begin
        xx:=x*x-y*y+p;
        yy:=2*x*y+q;
        r:=xx*xx+yy*yy;
        inc (cor);
        x:=xx;
        y:=yy;
      End;
      cor:=cor mod max_cor;
      PutPixel (nx, ny, cor);
      m:=chr (cor);
      if (Cor_Ant=Cor) Then
        if (Repeticoes [Posic]=254) Then Begin
          Inc (Repeticoes [Posic]);
          Cor_Ant:=-1;
        End
        Else Begin
          Inc (Repeticoes [Posic]);
          Bit:=Bit or pow (2, Posic-1);
        End
      Else Begin
        Inc (Posic);
        If (Posic=9) Then
          Gravar:=True
        Else Begin
          Repeticoes [Posic]:=0;
          Cores [Posic]:=Cor;
          Cor_Ant:=Cor;
        End
      End;
      If (Gravar) Then Begin
        Write (Saida, Chr (Bit));
        For Cont:=1 to 8 do Begin
          Teste:=Pow (2, Cont-1);
          If ((Bit and Teste)=Teste) Then
            Write (Saida, Chr (Repeticoes [Cont]));
          Write (Saida, Chr (Cores [Cont]));
        End;
        Bit:=0;
        Posic:=1;
        Repeticoes [Posic]:=0;
        Cores [Posic]:=Cor;
        Gravar:=False;
        Cor_Ant:=Cor;
      End
    End
  End;
  If (Posic>0) Then Begin
    Write (Saida, Chr (Bit));
    For Cont:=1 to Posic do Begin
      Teste:=Pow (2, Cont-1);
      If ((Bit and Teste)=Teste) Then
        Write (Saida, Chr (Repeticoes [Cont]));
      Write (Saida, Chr (Cores [Cont]));
    End;
  End;
  Close (Saida);

  cx := 0;
  cy := 0;
  flag := 0;
  Repeat
    PutPixel (cx, cy, 50);
    delay (5);
    PutPixel (cx, cy, 150);
    if (flag = 1) Then Begin
      cy := cy_ant + tela_y_max * (cx - cx_ant) div tela_x_max;
      PutPixel (cx, cy, 150);
    End;
    if keypressed Then Begin
      Resposta := ReadKey;
      Case Resposta of
        '8': Dec (cy);
        '2': Inc (cy);
        '4': Dec (cx);
        '6': Inc (cx);
        ' ': Halt (0);
        '<': Begin
          Novo_pmin := pmin + ( (qmax - qmin) * cx / tela_x_max );
          Novo_qmin := qmin + ( (pmax - pmin) * cy / tela_y_max );
          cx_ant := cx;
          cy_ant := cy;
          flag := 1;
        End;
        '>': Begin
          cy := cy_ant + tela_y_max * (cx - cx_ant) div tela_x_max;
          Novo_pmax := pmin + ( (qmax - qmin) * cx / tela_x_max );
          Novo_qmax := qmin + ( (pmax - pmin) * cy / tela_y_max );
        End
      End
    End
  Until (Resposta = CHR(13));
    CloseGraph;
  WriteLN ('pmin = ',Novo_pmin);
  WriteLN ('pmax = ',Novo_pmax);
  WriteLN ('qmin = ',Novo_qmin);
  WriteLN ('qmax = ',Novo_qmax);

  Resposta := ReadKey;
  Resposta := '*';

  pmax := Novo_pmax;
  pmin := Novo_pmin;
  qmax := Novo_qmax;
  qmin := Novo_qmin;

  Until (Resposta = 'Q');

End.
