Program Fractal;

Function Pow (Num, Expoente: Integer): Integer;
Begin
  If (Expoente=0) Then
    Pow:=1
  Else
    Pow:=Num*Pow (Num, Expoente-1);
End;

Var
  { Variaveis para o fractal }
  max_int, max_cor, nx, ny, tela_x_max, tela_y_max, cor: Integer;
  dx, dy, xx, yy, r, p, q, xmin, xmax, ymin, ymax, x0, y0, x, y,
  pmin, pmax, qmin, qmax, p0, q0: Real;
  { Variaveis para o modo grafico }
  max_num_cor, gd, gm: Integer;
  m: char;
  saida:Text;
  { Variaveis para a compressao }
  Cor_Ant, Cont, Posic: Integer;
  Bit, Teste: Byte;
  Cores, Repeticoes: Array [1..8] of Byte;
  Gravar: Boolean;

Begin
  tela_x_max:=640;
  tela_y_max:=480;
  assign (saida, 'MANDEL3.FRC');
  rewrite (saida);

  max_int:=100;
  max_cor:=256;
  xmin:=-2.25;
  xmax:=0.75;
  ymin:=-1.5;
  ymax:=1.5;
  pmin := -0.95;
  pmax := -0.88333;
  qmin := 0.23333;
  qmax := 0.3;
  dx:=(pmax-pmin)/(tela_x_max-1);
  dy:=(qmax-qmin)/(tela_y_max-1);
  nx:=-1;
  ny:=-1;


  cor_ant:=-1;
  bit:=0;
  Posic:=0;
  gravar:=False;

  nx:=-1;
  While (nx<=Tela_x_Max) do Begin
    Inc (nx);
    ny:=-1;
    While (ny<=Tela_y_Max) do Begin
      Inc (ny);
      p:=pmin+nx*dx;
      q:=qmin+ny*dy;
      cor:=0;
      x:=0;
      y:=0;
      r:=0;
      While (r <= max_int) and (cor < max_cor) do Begin
        xx:=x*x-y*y+p;
        yy:=2*x*y+q;
        r:=xx*xx+yy*yy;
        inc (cor);
        x:=xx;
        y:=yy;
      End;
      cor:=cor mod max_cor;
      m:=chr (cor);
      if (Cor_Ant=Cor) Then
        if (Repeticoes [Posic]=254) Then Begin
          Inc (Repeticoes [Posic]);
          Cor_Ant:=-1;
        End
        Else Begin
          Inc (Repeticoes [Posic]);
          Bit:=Bit or pow (2, Posic-1);
        End
      Else Begin
        Inc (Posic);
        If (Posic=9) Then
          Gravar:=True
        Else Begin
          Repeticoes [Posic]:=0;
          Cores [Posic]:=Cor;
          Cor_Ant:=Cor;
        End
      End;
      If (Gravar) Then Begin
        Write (Saida, Chr (Bit));
        For Cont:=1 to 8 do Begin
          Teste:=Pow (2, Cont-1);
          If ((Bit and Teste)=Teste) Then
            Write (Saida, Chr (Repeticoes [Cont]));
          Write (Saida, Chr (Cores [Cont]));
        End;
        Bit:=0;
        Posic:=1;
        Repeticoes [Posic]:=0;
        Cores [Posic]:=Cor;
        Gravar:=False;
        Cor_Ant:=Cor;
      End
    End
  End;
  If (Posic>0) Then Begin
    Write (Saida, Chr (Bit));
    For Cont:=1 to Posic do Begin
      Teste:=Pow (2, Cont-1);
      If ((Bit and Teste)=Teste) Then
        Write (Saida, Chr (Repeticoes [Cont]));
      Write (Saida, Chr (Cores [Cont]));
    End;
  End;
  Close (Saida);
End.
